package cn.com.infosec.math.ec;

import java.math.BigInteger;

class WTauNafMultiplier implements ECMultiplier {
   private ECPoint.F2m multiplyWTnaf(ECPoint.F2m p, ZTauElement lambda, PreCompInfo preCompInfo, byte a, byte mu) {
      ZTauElement[] var6;
      if (a == 0) {
         var6 = Tnaf.alpha0;
      } else {
         var6 = Tnaf.alpha1;
      }

      ECPoint.F2m var10000 = p;
      BigInteger p1 = Tnaf.getTw(mu, 4);
      return multiplyFromWTnaf(var10000, Tnaf.tauAdicWNaf(mu, lambda, (byte)4, BigInteger.valueOf(16L), p1, var6), preCompInfo);
   }

   private static ECPoint.F2m multiplyFromWTnaf(ECPoint.F2m p, byte[] u, PreCompInfo preCompInfo) {
      int var3 = ((ECCurve.F2m)p.getCurve()).getA().toBigInteger().byteValue();
      ECPoint.F2m[] preCompInfo1;
      if (preCompInfo != null && preCompInfo instanceof WTauNafPreCompInfo) {
         preCompInfo1 = ((WTauNafPreCompInfo)preCompInfo).getPreComp();
      } else {
         preCompInfo1 = Tnaf.getPreComp(p, (byte)var3);
         WTauNafPreCompInfo var5;
         var5 = new WTauNafPreCompInfo.<init>(preCompInfo1);
         p.setPreCompInfo(var5);
      }

      p = (ECPoint.F2m)p.getCurve().getInfinity();

      for(var3 = u.length - 1; var3 >= 0; --var3) {
         p = Tnaf.tau(p);
         if (u[var3] != 0) {
            if (u[var3] > 0) {
               p = p.addSimple(preCompInfo1[u[var3]]);
            } else {
               p = p.subtractSimple(preCompInfo1[-u[var3]]);
            }
         }
      }

      return p;
   }

   public ECPoint multiply(ECPoint point, BigInteger k, PreCompInfo preCompInfo) {
      if (point instanceof ECPoint.F2m) {
         WTauNafMultiplier var10000 = this;
         BigInteger var10001 = k;
         ECPoint.F2m var6;
         ECCurve.F2m var10002 = (ECCurve.F2m)(var6 = (ECPoint.F2m)point).getCurve();
         int point1 = var10002.getM();
         byte k1 = var10002.getA().toBigInteger().byteValue();
         byte var4 = var10002.getMu();
         BigInteger[] var5 = var10002.getSi();
         return var10000.multiplyWTnaf(var6, Tnaf.partModReduction(var10001, point1, k1, var5, var4, (byte)10), preCompInfo, k1, var4);
      } else {
         throw new IllegalArgumentException("Only ECPoint.F2m can be used in WTauNafMultiplier");
      }
   }
}
